<template>
  <section class="marvel-project-details__info">
    <img class="marvel-project-details__img"
      v-bind:alt="'image of ' + details.name"
      :src="details.thumbnail.path + '.' + details.thumbnail.extension" />

    <div class="marvel-project-details__text">
      <h2 class="marvel-project-details__name">
        <strong>{{ details.name }}</strong>
      </h2>

      <p class="marvel-project-details__desc"
        v-if="details.description && details.description.length">
        {{ details.description }}
      </p>

      <ul class="marvel-project-details__links" >
        <h3>I need more information !</h3>

        <li class="marvel-project-details__link" 
          v-for="url in details.urls"
          :key="url">
            <a v-bind:href="url.url">
              Go on {{ url.type }}
            </a>
        </li>
      </ul>
    </div>
  </section>

  <section
    class="marvel-project-details__appearance"
    v-if="details?.comics?.items?.length">
      <AppearanceMarvel :parentData="{title: 'Comics', data: details.comics.items }" />
  </section>

  <section class="marvel-project-details__appearance"
    v-if="details?.series?.items?.length">
    <AppearanceMarvel :parentData="{title: 'Series', data: details.series.items }" />
  </section>

  <section class="marvel-project-details__appearance"
    v-if="details?.stories?.items?.length">
    <AppearanceMarvel :parentData="{title: 'Stories', data: details.stories.items }" />
  </section>

  <section class="marvel-project-details__appearance"
    v-if="details?.events?.items?.length">
    <AppearanceMarvel :parentData="{title: 'Events', data: details.events.items }" />
  </section>
</template>

<script>
import axios from 'axios';
import md5 from 'md5';
import AppearanceMarvel from './AppearanceMarvel.vue';

export default {
  name: 'DetailsMarvel',
  components: {
    AppearanceMarvel
  },
  data() {
    return {
      details: [],
    }
  },
  created() {
    const API_PUBLIC_KEY = process.env.VUE_APP_MARVEL_API_KEY_PUBLIC
    const API_PRIVATE_KEY = process.env.VUE_APP_MARVEL_API_KEY_PRIVATE

    const timestamp = 1
    const hash = md5(`${timestamp}${API_PRIVATE_KEY}${API_PUBLIC_KEY}`)
    axios
      .get(`https://gateway.marvel.com:443/v1/public/characters/${this.$route.params.id}?ts=${timestamp}&apikey=${API_PUBLIC_KEY}&hash=${hash}`)
      .then(response => {
        this.details = response.data.data.results[0]
        console.log(response.data.data.results[0])
        console.log(this.details)
      })
      .catch(error => {
        console.log(error)
      })
  }
}
</script>

<style scoped lang='scss'>

    section:nth-child(2n+1) {
        background-color: $color-white;
    }
    
    section {
         padding: 2rem;
    }

    .marvel-project-details {
        &__info {
            display: flex;
            padding: 3rem 15rem;
            justify-content: flex-start;
        }
        
        &__img {
            height: 300px;
            width: 300px;
            border-radius: 50%;
            border: 5px solid;
            object-fit: cover;
        }

        &__text {
            padding: 0 0 0 5rem;
            text-align: left;
        }

        &__link {
            text-align: left;
            display: flex;
            align-items: center;

            &:before {
               /** TODO not work in Chrome  */
                content:url('~@/assets/img/avenger.png');
                width: 15px;
                height: 15px;
                display: flex;
                margin-right: 10px;
            }
        }    
    }
</style>
